#ifdef __cplusplus
extern "C" {
#endif

#define DECL2 __cdecl
//_stdcall

#ifdef _DLL_ 
#define EXPORTSPEC __declspec( dllexport )
#else
#define EXPORTSPEC
#endif


#ifndef _ClientOPC_
#define _ClientOPC_


typedef int (PASCAL *pCB_NewDataTag)(ULONG clienthandles, ULONG Users);
typedef int (PASCAL *pCB_NewDataGroup)(DWORD count, ULONG* clienthandles, ULONG Users);
typedef int (PASCAL *pCB_DisConnectServer)( ULONG Srv, ULONG Users);
typedef int (PASCAL *pCB_ConnectServer)( ULONG Srv, ULONG Users);
typedef int (PASCAL *pCB_Connection)( char* NameTag, ULONG Users);
typedef int (PASCAL *pCB_NewTag)( ULONG hTag, char* NameTag, int Type, int Access, ULONG Users);
typedef int (PASCAL *pCB_LogWrite)( char* LogString1, char* LogString2 );

typedef struct _init{
	int i;
	BOOL TestAddres;
	pCB_NewDataTag CB_NewDataTag;
	pCB_NewDataGroup CB_NewDataGroup;
	pCB_DisConnectServer CB_DisConnectServer;
	pCB_ConnectServer CB_ConnectServer;
	pCB_LogWrite CB_LogWrite;
	pCB_NewTag CB_NewTag;
	pCB_Connection CB_Connection;
}init;

typedef struct _srvname{
	char NameMash[256];
	char NameServ[256];
	FILETIME ftStartTime;
	FILETIME ftCurrentTime;
	FILETIME ftLastUpdateTime;
	OPCSERVERSTATE dwServerState;
	DWORD dwGroupCount;
	DWORD dwBandWidth;
	WORD wMajorVersion;
	WORD wMinorVersion;
	WORD wBuildNumber;
	WORD wReserved;
	char VendorInfo[256];
}srvname;

typedef struct _val{
	VARIANT values;
	ULONG Type;
	ULONG Access;
	ULONG quality;
	SYSTEMTIME time;
}val;


EXPORTSPEC ULONG DECL2 Initialize(init* pInit);
EXPORTSPEC ULONG DECL2 DeInitialize();
EXPORTSPEC ULONG DECL2 NewDevice(HWND hWnd);
EXPORTSPEC ULONG DECL2 AddDevice(char* nm, char* ns, ULONG Users);
EXPORTSPEC ULONG DECL2 GetDeviceInfo(ULONG d, srvname*inf);
EXPORTSPEC ULONG DECL2 AddGroup(ULONG d, char* ng, BOOL active, ULONG reqUpdateRate_ms, ULONG Users);

EXPORTSPEC ULONG DECL2 AddTag(ULONG d, char* nt, ULONG Users);
EXPORTSPEC ULONG DECL2 NewTag(HWND hWnd, ULONG d, ULONG Users);

EXPORTSPEC ULONG DECL2 DeleteDevice(ULONG d);
EXPORTSPEC ULONG DECL2 DeleteGroup(ULONG g);
EXPORTSPEC ULONG DECL2 DeleteTag(ULONG t);

EXPORTSPEC ULONG DECL2 GetConnection(ULONG d, ULONG Users);

EXPORTSPEC ULONG DECL2 StartProcess(ULONG g);
EXPORTSPEC ULONG DECL2 StopProcess(ULONG g);
EXPORTSPEC ULONG DECL2 GetProcess(ULONG g);

EXPORTSPEC ULONG DECL2 ReadTag(ULONG t);
EXPORTSPEC ULONG DECL2 WriteTag(ULONG t);

EXPORTSPEC ULONG DECL2 GetAddrTag(ULONG t);
#endif


#ifdef __cplusplus
 }
#endif




