typedef union {
	unsigned char Mpi;				// MPI Stationsadresse	(2)
	unsigned char Ip[4];			// IP Adresse			(192.168.0.1)
	unsigned char Mac[6];			// MAC Adresse			(08-00-06-01-AA-BB)
} CON_ADR_TYPE;
typedef struct {
	CON_ADR_TYPE Adr;				// Verbindungsadresse
	unsigned char AdrType;			// Typ der Adresse MPI(1) IP(2) MAC(3)
	unsigned char SlotNr;			// Slot-Nummer
	unsigned char RackNr;			// Rack-Nummer
} CON_TABLE_TYPE;
typedef struct
	{
	unsigned char  adr;          /* stationsadresse     default 2          */
	unsigned char  segmentid;    /* segment id          default 0          */
	unsigned char  slotno;       /* slot no             default 1          */
	unsigned char  rackno;       /* rack no             default 0          */
	} adr_table_type;
typedef int (APIENTRY* F1)(char,char *,adr_table_type *);
typedef int (APIENTRY* F2)();
typedef int (APIENTRY* F3)(int,int,void*);
typedef int (APIENTRY* F4)(int,int);
typedef int (APIENTRY* F5)(int,int,int,void*);
typedef int (APIENTRY* F6)(unsigned short, char*, unsigned short, CON_TABLE_TYPE *);
typedef int (APIENTRY* F7)(unsigned short);
typedef int (APIENTRY* F8)(char, unsigned short, unsigned short, unsigned long, unsigned long, unsigned char *, unsigned long *);
//typedef int (APIENTRY* F8)(char, unsigned short, unsigned long, unsigned long, unsigned long, unsigned char *, unsigned long *);
typedef int (APIENTRY* F9)(unsigned short, unsigned short, unsigned char);
//typedef int (APIENTRY* F10)(char, unsigned short, unsigned short, unsigned long, unsigned long, unsigned char *);
typedef int (APIENTRY* F10)(char, unsigned short, unsigned short, int, unsigned long, unsigned char *);
F1 load_tool;
F2 unload_tool;
F3 as200_m_field_read;
F3 as200_m_field_write;
F4 as200_mb_setbit;      // no, bitno
F4 as200_mb_resetbit;
F3 as200_vs_field_read;
F3 as200_vs_field_write;
F3 as200_e_field_read;
F3 as200_a_field_read;
F3 as200_a_field_write;

F3 m_field_read;
F3 m_field_write;
F4 mb_setbit;
F4 mb_resetbit;
F5 d_field_read;
F5 d_field_write;
F3 e_field_read;
F3 a_field_read;
F3 a_field_write;

F6 LoadConnection;
F7 UnloadConnection;
F8 field_read;
F9 mb_setbit_6;
F10 field_write;
//-------------------------------------------------------------------------------
int fi(int *beg,int *end)       //      
{int x=4; if (t[o[no].tag].type==bit | t[o[no].tag].type==byte_) x=1; if (t[o[no].tag].type==word) x=2;
if (*beg > t[o[no].tag].adr) *beg = t[o[no].tag].adr;
if (*end < t[o[no].tag].adr+x) *end = t[o[no].tag].adr+x;
 return(0);}
//-------------------------------------------------------------------------------
int add_m(int x) {ListBox_AddString(GetDlgItem(hw,no+100),mes[x]); xx[c]=x; c++; return(0);}//      _
//-------------------------------------------------------------------------------
int del_m(int x) {int y,z=0; for (y = 0; y < c; y++)//      ,  .        ,     ,  _
{if (xx[y-z]==x) ListBox_DeleteString(GetDlgItem(hw,no+100),y-z++);  if (z>0) xx[y+1-z]=xx[y+1];
} c=c-z; return(0);}
//-------------------------------------------------------------------------------
int out(int range,int beg)        //   , ran - , beg -  (.  )
{for (no = 0; no < co; no++)
  { //itoa (DB[n_DB],str,10); itoa (t[o[no].tag].N_DB,str1,10); MessageBox(NULL,str,str1,0);
         if (t[o[no].tag].range==range & o[no].tag>=0 & o[no].typ!=button) //  , _
//         if (t[o[no].tag].range==range & o[no].tag>=0 ) //  , _
         if (t[o[no].tag].range !=1 | t[o[no].tag].N_DB==DB[nd])
      { buf = buffer + t[o[no].tag].adr - beg; copy(str,"####"); u.i=0;
        if (!OK)                       // 

            {if (t[o[no].tag].type==bit){b=1; b=b << t[o[no].tag].bit; if(buf[0]&b)copy(str,"1");else copy(str,"0"); u.i=(str[0]-'0')*10;}

             if (t[o[no].tag].type==byte_) { u.i=buf[0]; itoa (u.i,str,10);}

             if (t[o[no].tag].type==word){u.i=256*buf[0] + buf[1]; if (u.i>0x7fff) u.i=0xffff0000+u.i; itoa (u.i,str,10);}

             if (t[o[no].tag].type==dword){u.i=16777216*buf[0] +65536*buf[1] +256*buf[2] +buf[3];itoa (u.i,str,10);}

             if (t[o[no].tag].type==real){u.chu[0]=buf[3]; u.chu[1]=buf[2]; u.chu[2]=buf[1]; u.chu[3]=buf[0];//float        
                                         if (u.chu[3]!=0x7f & u.chu[3]!=0xff){gcvt(u.f,7,str); u.i=(int)u.f;}}

            }
            out_r();
       }
    }
return(0);}
//-------------------------------------------------------------------------------
DWORD WINAPI Thread_Prodave(LPVOID Par)          //  S7ONLINE PPI
{   CON_TABLE_TYPE con;   // CP   CPU  con.SlotNr=2; ( MPI con.SlotNr=0;)  IM157-8 PNP  con.SlotNr=0  2
    adr_table_type adr_table[5] = { {2,0,2,0},{0,0,2,0},{0,0,2,0},{0,0,2,0},{0,0,0,0}};
if (sou==prodave)
 { hLib=LoadLibrary("w95_s7.dll"); if (hLib==0){MessageBox(NULL,"No load w95_s7.dll","",0); goto end;}
  load_tool=           (F1)GetProcAddress(hLib,"load_tool");           if (load_tool ==NULL) MessageBox(NULL,"No function_1","",0);
  unload_tool=         (F2)GetProcAddress(hLib,"unload_tool");         if (unload_tool == NULL) MessageBox(NULL,"No function_2","",0);
  as200_m_field_read=  (F3)GetProcAddress(hLib,"as200_m_field_read");  if (as200_m_field_read ==  NULL) MessageBox(NULL,"No function_3","",0);
  as200_m_field_write= (F3)GetProcAddress(hLib,"as200_m_field_write"); if (as200_m_field_write ==  NULL) MessageBox(NULL,"No function_4","",0);
  as200_mb_setbit=     (F4)GetProcAddress(hLib,"as200_mb_setbit");     if (as200_mb_setbit ==  NULL) MessageBox(NULL,"No function_5","",0);
  as200_mb_resetbit=   (F4)GetProcAddress(hLib,"as200_mb_resetbit");   if (as200_mb_resetbit ==  NULL) MessageBox(NULL,"No function_6","",0);
  as200_vs_field_read= (F3)GetProcAddress(hLib,"as200_vs_field_read"); if (as200_vs_field_read ==  NULL) MessageBox(NULL,"No function_7","",0);
  as200_vs_field_write=(F3)GetProcAddress(hLib,"as200_vs_field_write");if (as200_vs_field_write ==  NULL) MessageBox(NULL,"No function_8","",0);
  as200_e_field_read=  (F3)GetProcAddress(hLib,"as200_e_field_read");  if (as200_e_field_read ==  NULL) MessageBox(NULL,"No function_11","",0);
  as200_a_field_read=  (F3)GetProcAddress(hLib,"as200_a_field_read");  if (as200_a_field_read ==  NULL) MessageBox(NULL,"No function_9","",0);
  as200_a_field_write= (F3)GetProcAddress(hLib,"as200_a_field_write"); if (as200_a_field_write ==  NULL) MessageBox(NULL,"No function_10","",0);
  load_tool=    (F1)GetProcAddress(hLib,"load_tool");     if (load_tool ==NULL) MessageBox(NULL,"No function_1","",0);
  unload_tool=  (F2)GetProcAddress(hLib,"unload_tool");   if (unload_tool == NULL) MessageBox(NULL,"No function_2","",0);
  m_field_read= (F3)GetProcAddress(hLib,"m_field_read");  if (m_field_read ==  NULL) MessageBox(NULL,"No function_3","",0);
  m_field_write=(F3)GetProcAddress(hLib,"m_field_write"); if (m_field_write ==  NULL) MessageBox(NULL,"No function_4","",0);
  mb_setbit=    (F4)GetProcAddress(hLib,"mb_setbit");     if (mb_setbit ==  NULL) MessageBox(NULL,"No function_5","",0);
  mb_resetbit=  (F4)GetProcAddress(hLib,"mb_resetbit");   if (mb_resetbit ==  NULL) MessageBox(NULL,"No function_6","",0);
  d_field_read= (F5)GetProcAddress(hLib,"d_field_read");  if (d_field_read ==  NULL) MessageBox(NULL,"No function_7","",0);
  d_field_write=(F5)GetProcAddress(hLib,"d_field_write"); if (d_field_write ==  NULL) MessageBox(NULL,"No function_8","",0);
  e_field_read= (F3)GetProcAddress(hLib,"e_field_read");  if (e_field_read ==  NULL) MessageBox(NULL,"No function_11","",0);
  a_field_read= (F3)GetProcAddress(hLib,"a_field_read");  if (a_field_read ==  NULL) MessageBox(NULL,"No function_9","",0);
  a_field_write=(F3)GetProcAddress(hLib,"a_field_write"); if (a_field_write ==  NULL) MessageBox(NULL,"No function_10","",0);
  adr_table[0].adr=Iadr;}
 else
  { //                                                                            1200 CPU 1212C  con.SlotNr=0  1
    //  con.RackNr=0;                                                             S7-400  con.SlotNr=2
    //con.Adr.Ip[0]=192; con.Adr.Ip[1]=168; con.Adr.Ip[2]=0; con.Adr.Ip[3]=105;   ET200S IM157-8 PNP  con.SlotNr=0  2
    con.RackNr=0; if (interf==0) {con.Adr.Mpi=Iadr; con.AdrType=1; con.SlotNr=0;}
        else {con.AdrType=2; con.SlotNr=0;con.Adr.Ip[0]=Ip_adr[0]; con.Adr.Ip[1]=Ip_adr[1]; con.Adr.Ip[2]=Ip_adr[2]; con.Adr.Ip[3]=Ip_adr[3];}
    hLib            =LoadLibrary("Prodave6.dll");                     if (hLib==0){MessageBox(NULL,"No load Prodave6.dll","",0); goto end;}
    LoadConnection  =(F6)GetProcAddress(hLib,"LoadConnection_ex6");   if (LoadConnection ==NULL) MessageBox(NULL,"No function_1","",0);
    UnloadConnection=(F7)GetProcAddress(hLib,"UnloadConnection_ex6"); if (UnloadConnection ==NULL) MessageBox(NULL,"No function_2","",0);
//    field_read      =(F8)GetProcAddress(hLib,"field_read_ex6");       if (field_read ==NULL) MessageBox(NULL,"No function_3","",0);
    field_read      =(F8)GetProcAddress(hLib,"as200_field_read_ex6");       if (field_read ==NULL) MessageBox(NULL,"No function_3","",0);
    mb_setbit_6     =(F9)GetProcAddress(hLib,"mb_setbit_ex6");        if (mb_setbit_6 ==NULL) MessageBox(NULL,"No function_4","",0);
    field_write    =(F10)GetProcAddress(hLib,"field_write_ex6");      if (field_write ==NULL) MessageBox(NULL,"No function_5","",0);
}

if (arch==1) init_SQL();

//----------------------  DB---------------------------------------------------------
int nx; cd=0;
    for (no = 0; no < co; no++)
// { if  (o[no].typ!=button & o[no].tag>=0 & t[o[no].tag].range==V)    //2-edit  4-picture,    
 { if  (o[no].tag>=0 & t[o[no].tag].range==V)    //2-edit  4-picture,    
   { nx=0;
       for (nd = 0; nd < cd; nd++) if (t[o[no].tag].N_DB == DB[nd])  nx++;       
       if (nx==0) {DB[cd] = t[o[no].tag].N_DB; cd++;}
 } }   
if (cd>10) MessageBox(NULL,"  DB","",0);
//itoa (cd,str,10); MessageBox(NULL,str,"c_DB",0);

bM=bI=bQ=100000; eM=eI=eQ=0;   for (nd = 0; nd < cd; nd++) {bV[nd]=100000; eV[nd]=0;}  //    
    
//       bV[0]=100000; eV[0]=0;
for (no = 0; no < co; no++)
// { if  (o[no].typ!=button & o[no].tag>=0)    //2-edit  4-picture,    
 { if  (o[no].tag>=0)    //2-edit  4-picture,    
   { if (t[o[no].tag].range==M) fi(&bM,&eM); //0-M,
//     if (t[o[no].tag].range==V) fi(&bV,&eV); //N_DB=t[o[no].tag].N_DB;}
//    if (t[o[no].tag].range==V) fi(&bV[0],&eV[0]); 
     
     for (nd = 0; nd < cd; nd++)
       if (t[o[no].tag].range==V & t[o[no].tag].N_DB==DB[nd]) fi(&bV[nd],&eV[nd]); 
      
     if (t[o[no].tag].range==I) fi(&bI,&eI);
     if (t[o[no].tag].range==Q) fi(&bQ,&eQ);
   }
 }
//  wsprintf(str,"bM=%d, eM=%d, bV=%d, eV=%d, bI=%d, eI=%d, bQ=%d, eQ=%d",bM,eM,bV,eV,bI,eI,bQ,eQ);SetWindowText(hw,str);

 u.i=0; pre=0; c=0; OK=-1;  //  -  unload_tool, load_tool

while(en==3)    //   runtime
 {  if (OK!=0)
    {
     if (sou==prodave) {unload_tool(); if (load_tool(1,NULL,(adr_table_type*)adr_table) != 0) {MessageBox(NULL,"Error connect","",0);en=4;}}
        else {UnloadConnection(1); if (LoadConnection(1,point,sizeof(con),&con)) {MessageBox(NULL,"No connection","",0);en=4;}}
    }
//    if (sou==4)
//    {  if (eM!=0) {OK=as200_m_field_read (bM,eM - bM,buffer); out(0,bM);}   //  M 
//       if (eV!=0) {OK=as200_vs_field_read(bV,eV - bV,buffer); out(1,bV);}   //  V 
//       if (eI!=0) {OK=as200_e_field_read (bI,eI - bI,buffer); out(2,bI);}   //  I 
//       if (eQ!=0) {OK=as200_a_field_read (bQ,eQ - bQ,buffer); out(3,bQ);}}  //  Q 
    if (sou==prodave)
    {  if (eM!=0) {OK=m_field_read (bM,eM - bM,buffer); out(0,bM);}   //  M 
//       if (eV!=0) {OK=d_field_read(N_DB,bV,eV - bV,buffer); out(1,bV);}   //  DB1 
       
            for (nd = 0; nd < cd; nd++)
       if (eV[nd]!=0) {OK=d_field_read(DB[nd],bV[nd],eV[nd] - bV[nd],buffer); out(1,bV[nd]); //  DB 
//       itoa (bV[nd],str,10); itoa (eV[nd],str1,10); MessageBox(NULL,str1,str,0);
       }  


       if (eI!=0) {OK=e_field_read (bI,eI - bI,buffer); out(2,bI);}   //  I 
       if (eQ!=0) {OK=a_field_read (bQ,eQ - bQ,buffer); out(3,bQ);}   //  Q 
    }
    if (sou==prodave_6)
    {  if (eM!=0) {OK = field_read ('m',   0, bM, eM - bM, sizeof(buffer), buffer, &ul); out(0,bM);}
//       if (eV!=0) {OK = field_read ('d',N_DB, bV, eV - bV, sizeof(buffer), buffer, &ul); out(1,bV);}
//      if (eV[0]!=0) {OK = field_read ('d',N_DB, bV[0], eV[0] - bV[0], sizeof(buffer), buffer, &ul); out(1,bV[0]);}

            for (nd = 0; nd < cd; nd++)
       if (eV[nd]!=0) {OK = field_read ('d',DB[nd], bV[nd], eV[nd] - bV[nd], sizeof(buffer), buffer, &ul); out(1,bV[nd]);}
       
       
       if (eI!=0) {OK = field_read ('e',   0, bI, eI - bI, sizeof(buffer), buffer, &ul); out(2,bI);}
       if (eQ!=0) {OK = field_read ('v',   0, bQ, eQ - bQ, sizeof(buffer), buffer, &ul); out(3,bQ);}
    }

no=0; while (no < co & o[no].mode!=3) no++;      //     .  , o[i].type = 2,3 -edit,button
if (no < co)            // _
  { o[no].mode=0;
    if (o[no].typ==button & t[o[no].tag].type==bit & t[o[no].tag].range==M & o[no].tag>=0) // bool,  M,    
        {// if (o[no].opt & sou==4)  if (as200_mb_setbit(t[o[no].tag].adr,t[o[no].tag].bit)!=0) MessageBox(NULL,"Err setbit","",0);
         // if (!o[no].opt & sou==4) if (as200_mb_resetbit(t[o[no].tag].adr,t[o[no].tag].bit)!=0) MessageBox(NULL,"Err setbit","",0);
          if (o[no].opt & sou==prodave)  if (mb_setbit(t[o[no].tag].adr,t[o[no].tag].bit)!=0) MessageBox(NULL,"Err setbit","",0);
          if (!o[no].opt & sou==prodave) if (mb_resetbit(t[o[no].tag].adr,t[o[no].tag].bit)!=0) MessageBox(NULL,"Err setbit","",0);
          if (sou==prodave_6) mb_setbit_6(t[o[no].tag].adr,t[o[no].tag].bit,o[no].opt);
        }
    if ((o[no].typ==edit |o[no].typ==slider |o[no].typ==button) & o[no].tag>=0 & t[o[no].tag].type!=bit)
     {buf = buffer; if (o[no].typ==edit)
        {Edit_GetText(GetDlgItem(hw,ed),str,10);
        if (t[o[no].tag].type==byte_) {u.i=ch_i(str); buf[0]=u.chu[0]; u.i=1;} // byte
        if (t[o[no].tag].type==word) {u.i=ch_i(str); buf[1]=u.chu[0]; buf[0]=u.chu[1]; u.i=2;} // int
        if (t[o[no].tag].type==dword){u.i=ch_i(str); buf[3]=u.chu[0]; buf[2]=u.chu[1]; buf[1]=u.chu[2]; buf[0]=u.chu[3]; u.i=4;} // dword
        if (t[o[no].tag].type==real) {u.f=atof(str); buf[0]=u.chu[3]; buf[1]=u.chu[2]; buf[2]=u.chu[1]; buf[3]=u.chu[0]; u.i=4;}} // float
      if (o[no].typ==slider)
//        {u.i=SendMessage(GetDlgItem(hw,ed), TBM_GETPOS,0,0); if (o[no].opt==0) u.i=100-u.i; //   _
        {u.i=SendMessage(GetDlgItem(hw,ed), TBM_GETPOS,0,0); if (o[no].w<o[no].h) u.i=o[no].opt-u.i; //   _
        if (t[o[no].tag].type==byte_){ buf[0]=u.chu[0]; u.i=1;} // byte
        if (t[o[no].tag].type==word) { buf[1]=u.chu[0]; buf[0]=u.chu[1]; u.i=2;} // int
        if (t[o[no].tag].type==dword){ buf[3]=u.chu[0]; buf[2]=u.chu[1]; buf[1]=u.chu[2]; buf[0]=u.chu[3]; u.i=4;} // dword
        if (t[o[no].tag].type==real) { u.f=u.i; buf[0]=u.chu[3]; buf[1]=u.chu[2]; buf[2]=u.chu[1]; buf[3]=u.chu[0]; u.i=4;}} // float
      if (o[no].typ==button |o[no].typ==swit)
        {u.i=o[no].opt; if (o[no].i!=0 |o[no].typ==swit) u.i=0;
        if (t[o[no].tag].type==byte_){ buf[0]=u.chu[0]; u.i=1;} // byte
        if (t[o[no].tag].type==word) { buf[1]=u.chu[0]; buf[0]=u.chu[1]; u.i=2;} // int
        if (t[o[no].tag].type==dword){ buf[3]=u.chu[0]; buf[2]=u.chu[1]; buf[1]=u.chu[2]; buf[0]=u.chu[3]; u.i=4;} // dword
        if (t[o[no].tag].type==real) { u.f=u.i; buf[0]=u.chu[3]; buf[1]=u.chu[2]; buf[2]=u.chu[1]; buf[3]=u.chu[0]; u.i=4;}} // float
//      if (sou==4)
//       {if (t[o[no].tag].range==M) if (as200_m_field_write(t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);//break;
//        if (t[o[no].tag].range==V) if (as200_vs_field_write(t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);
//        if (t[o[no].tag].range==Q) if (as200_a_field_write(t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);}
      if (sou==prodave)
       {if (t[o[no].tag].range==M) if (m_field_write(t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);//break;
        if (t[o[no].tag].range==V) if (d_field_write(t[o[no].tag].N_DB,t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);
        if (t[o[no].tag].range==Q) if (a_field_write(t[o[no].tag].adr,u.i,buf)!=0) MessageBox(NULL,"Err write","",0);}
      if (sou==prodave_6)
       {if (t[o[no].tag].range==M) if (field_write('m',0,t[o[no].tag].adr,u.i,4,buf)) MessageBox(NULL,"Err write","",0);
        if (t[o[no].tag].range==V) if (field_write('d',t[o[no].tag].N_DB,t[o[no].tag].adr,u.i,4,buf)) MessageBox(NULL,"Err write","",0);
        if (t[o[no].tag].range==Q) if (field_write('a',0,t[o[no].tag].adr,u.i,4,buf))MessageBox(NULL,"Err write","",0); // _
       }
     }
   }
Sleep (delay);
if (en==5) { np=TabCtrl_GetCurFocus(hp); input(0); clear_(); paint_r(); //     Runtime
      for (no = 0; no < co; no++) { if ( o[no].typ!=picture & o[no].typ!=trend)
      {if (o[no].page ==np ) ShowWindow(o[no].hw, SW_SHOW ); else  ShowWindow(o[no].hw, SW_HIDE );}} en=3;}

 }
 if (sou==prodave) unload_tool(); else UnloadConnection(1);
 FreeLibrary( hLib);
 if (arch==1) {rc=SQLDisconnect_(hdbc); if(rc!=0 & rc!=1)MessageBox(NULL,"No disconnect","",0);}
 if (arch==1) {rc=SQLFreeHandle_(2,hdbc);if(rc!=0)MessageBox(NULL,"No 2","",0);}
 if (arch==1) {rc=SQLFreeHandle_(1,henv);if(rc!=0)MessageBox(NULL,"No 1","",0);}
 if (arch==1) FreeLibrary(hLib2);
 end: SendMessage(hw,WM_USER+1,0,0);
 return(0);}
